// SerDownloadDlg.h : header file
//

#if !defined(AFX_SerDOWNLOADDLG_H__7E663C19_39D4_4DAD_8D2D_BEE0E66F453D__INCLUDED_)
#define AFX_SerDOWNLOADDLG_H__7E663C19_39D4_4DAD_8D2D_BEE0E66F453D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "afxtempl.h"
#include "comm.h"
#include "DebugWin.h"

#pragma pack(1)
extern "C" {
#include "SerDownl.h"
};
#pragma pack(1)

/////////////////////////////////////////////////////////////////////////////
// CSerDownloadDlg dialog

class IPList
{
public:
	CString Description;
	int MTU;
	bool NeedsRamCode;
	bool HasCodeInXmem;
	int BlockSize;
};

class CSerDownloadDlg : public CDialog
{
// Construction
public:
	CSerDownloadDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CSerDownloadDlg();	// standard constructor
public:
	int m_UserBlock;
	bool m_CheckUserBlock;
	void CloseDebugOut();
	void CreateDebugOut();
	bool m_TermIsDebug;
	void TerminalWrite(CDebugWin * win,char * buff,int len);
	bool m_RebootAck;
	void CloseTerminal();
	int m_SyncTimer;
	int m_ConnectTimer;
	void ConnectProcess();
	bool m_NoPoll;
	void EnableModemCtls(bool enable);
	void Hangup();
	int m_SearchTries;
	enum {C_IDLE,C_INIT,C_RINGW,C_CONNECTW,C_CONNECTED} m_ConnectState;
	bool m_Connected;
	bool SendModemCommand(CString & cmd);
	bool SendPacket(SER_COMM_HEADER * pkt);
	bool CheckPacket(SER_COMM_HEADER * pkt);
	unsigned short CRC16(unsigned char * pcdataptr,unsigned short uslength,unsigned short uscrc);
	bool GetPacket(SER_COMM_HEADER * pkt);
	CComm Comm;
	bool CheckRx();
	int m_Update;
	void AddStatus(LPCSTR s);
	bool m_Abort;
	bool m_XSizeAck;
	bool DownloadCode(int boardnum,CString filename,int type);
	CArray<IPList,IPList&> m_IPList;
	bool m_Ack;
	void ASockInit();
	bool m_ASockInit;
	CAsyncSocket m_ASock;
	void Ping(bool verbose=true);
	CDebugWin * m_DebugWin,*m_DebugOut;
// Dialog Data
	//{{AFX_DATA(CSerDownloadDlg)
	enum { IDD = IDD_SERDOWNLOAD_DIALOG };
	CProgressCtrl	m_Progress;
	CString	m_Status;
	CString	m_Boards;
	CString	m_RomFile;
	BOOL	m_Answer;
	CString	m_Baud;
	CString	m_Port;
	BOOL	m_Modem;
	CString	m_ModemInit;
	CString	m_PhoneNumber;
	CString	m_RamFile;
	int		m_Retries;
	BOOL	m_ShortPackets;
	BOOL	m_ForceRam;
	BOOL	m_RS485;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSerDownloadDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSerDownloadDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSearch();
	afx_msg void OnDownload();
	afx_msg void OnAbort();
	afx_msg void OnAbout();
	afx_msg void OnSetROMFile();
	afx_msg void OnClear();
	afx_msg void OnConnect();
	afx_msg void OnSetRamFile();
	afx_msg void OnModem();
	virtual void OnOK();
	afx_msg void OnTerminal();
	afx_msg void OnShortPackets();
	afx_msg void OnChangeRetries();
	afx_msg void OnRs485();
	afx_msg void OnUBCheck();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SerDOWNLOADDLG_H__7E663C19_39D4_4DAD_8D2D_BEE0E66F453D__INCLUDED_)
